{mik 19/08/98 to use in wizard}

unit Mpanel;
interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, controls, Forms, ExtCtrls;

type
  TParentPanel = class(TCustomPanel)
  private
    FForm: TForm;
    procedure SetUpForm(Value: TForm);
  protected
    procedure Paint; override;
    procedure Resize; override;
  public
    constructor Create(AOwner: TComponent); override;
    property Form: TForm read FForm write SetUpForm;
  published
    Property Enabled;
    Property Align;
  end;

procedure register;

implementation

procedure Register;
begin
     RegisterComponents('Samples', [TParentPanel]);
end;

constructor TParentPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 40;
  Height := 40;
  FForm := nil;
  BorderStyle := bsNone;
end;

procedure TParentPanel.SetUpForm(Value: TForm);
begin
  if value = nil then exit;
  if Value <> FForm then
  begin
    FForm := Value;
    if (FForm <> nil) then
    begin
      FForm.Visible := False;
      FForm.Parent := Self;
      FForm.BorderIcons := [];
      FForm.BorderStyle := bsNone;
      FForm.AutoScroll := True;
      FForm.SetBounds(0, 0, width, height);
      FForm.Visible := True;
      FForm.setfocus;
    end;
  end;
end;

procedure TParentPanel.Paint;
begin
  caption := '';
  inherited Paint;
  if FForm <> nil then
    SetUpForm(FForm);
end;

procedure TParentPanel.Resize;
begin
  inherited Resize;
  if csDestroying in ComponentState then
    begin
     FForm.close;
     FForm.free;
    end;
  if (FForm <> nil) and not (csDestroying in ComponentState) then
      FForm.SetBounds(0, 0, width, height);
end;
end.
